
class CCommandWindow;
#define WM_THREADFIREEVENT WM_USER+101
#include "mixx.h"

class CCommandCtrl : public COleControl, public Transport, public Thread
{
	DECLARE_DYNCREATE(CCommandCtrl)

public:
	CCommandCtrl();

	//{{AFX_VIRTUAL(CCommandCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

protected:
	~CCommandCtrl();

	DECLARE_OLECREATE_EX(CCommandCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CCommandCtrl)      // GetTypeInfo
	DECLARE_OLECTLTYPE(CCommandCtrl)		// Type name and misc status

	//{{AFX_MSG(CCommandCtrl)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	//{{AFX_DISPATCH(CCommandCtrl)
	short m_listenPort;
	afx_msg void OnListenPortChanged();
	afx_msg void SendCommand(LPCTSTR host, short port, LPCTSTR txt);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

public:
   //{{AFX_EVENT(CCommandCtrl)
	void FireOnCommand(LPCTSTR peername, LPCTSTR txt)
		{FireEvent(eventidOnCommand,EVENT_PARAM(VTS_BSTR  VTS_BSTR), peername, txt);}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

public:
	enum {
	//{{AFX_DISP_ID(CCommandCtrl)
	dispidListenPort = 1L,
	dispidSendCommand = 2L,
	eventidOnCommand = 1L,
	//}}AFX_DISP_ID
	};

   char *tmp_peername, *tmp_txt;
   HWND hwndTarget;
   CCommandWindow *mywnd;
   void Run(void);
};

class CCommandWindow: public CWnd
{
public:
	CCommandWindow(CCommandCtrl *pCtrl) { m_pControl=pCtrl; }
	LRESULT OnFireEventForThread(WPARAM wParam, LPARAM lParam);
	HWND Create();

protected:
	CCommandCtrl *m_pControl;
	DECLARE_MESSAGE_MAP()
};

