
class CVideoShowCtrl : public COleControl
{
	DECLARE_DYNCREATE(CVideoShowCtrl)

public:
	CVideoShowCtrl();

	//{{AFX_VIRTUAL(CVideoShowCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

protected:
	~CVideoShowCtrl();

	DECLARE_OLECREATE_EX(CVideoShowCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CVideoShowCtrl)      // GetTypeInfo
	DECLARE_OLECTLTYPE(CVideoShowCtrl)		// Type name and misc status

	//{{AFX_MSG(CVideoShowCtrl)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	//{{AFX_DISPATCH(CVideoShowCtrl)
	BOOL m_autoSize;
	BOOL m_stretch;
	BOOL m_autoRedraw;
	afx_msg void OnAutoRedrawChanged();
	afx_msg void Draw(long bmph, long data);
	afx_msg LPPICTUREDISP GetPicture(long bmph, long data);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

	//{{AFX_EVENT(CVideoShowCtrl)
	void FireResize()
		{FireEvent(eventidResize,EVENT_PARAM(VTS_NONE));}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

public:
	enum {
	//{{AFX_DISP_ID(CVideoShowCtrl)
	dispidAutoSize = 1L,
	dispidStretch = 2L,
	dispidAutoRedraw = 3L,
	dispidDraw = 4L,
	dispidPicture = 5L,
	eventidResize = 1L,
	//}}AFX_DISP_ID
	};

   long m_width, m_height;
   HDC hdcMem;
   HBITMAP hbitmap;
};
